﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;

namespace UPP.Engine
{
    public static class Path
    {
        private const string DEFAULT_OUTPUT_CACHE_CLASSES_PATH = "Assets/Unity++ Game/CACHE/Classes";
        private const string DEFAULT_OUTPUT_CACHE_CLASSES_DB = "Assets/Unity++ Game/CACHE/ClassesDB.asset";
        private const string DEFAULT_OUTPUT_CACHE_PROPERTIES_PATH = "Assets/Unity++ Game/CACHE/Properties";
        private const string DEFAULT_OUTPUT_CACHE_PROPERTIES_DB = "Assets/Unity++ Game/CACHE/PropertiesDB.asset";
        private const string DEFAULT_OUTPUT_CACHE_TEMPLATES_PATH = "Assets/Unity++ Game/CACHE/Templates";
        private const string DEFAULT_OUTPUT_CACHE_TEMPLATES_DB = "Assets/Unity++ Game/CACHE/TemplatesDB.asset";
        private const string DEFAULT_OUTPUT_CLASSES = "Assets/Unity++ Game/Classes";
        private const string DEFAULT_OUTPUT_TEMPLATES = "Assets/Unity++ Game/Templates";
        private const string DEFAULT_OUTPUT_PREFABS = "Assets/Unity++ Game/Prefabs";
        private const string DEFAULT_COMPILER_DB = "Assets/Unity++ Game/CACHE/CompilerDB.asset";

        public const string KEY_OUTPUT_CACHE_CLASSES_PATH = "UPP_Output_Cache_Classes";
        public const string KEY_OUTPUT_CACHE_CLASSES_DB = "UPP_Output_Cache_Classes_DB";
        public const string KEY_OUTPUT_CACHE_PROPERTIES_PATH = "UPP_Output_Cache_Properties";
        public const string KEY_OUTPUT_CACHE_PROPERTIES_DB = "UPP_Output_Cache_Properties_DB";
        public const string KEY_OUTPUT_CACHE_TEMPLATES_PATH = "UPP_Output_Cache_Templates";
        public const string KEY_OUTPUT_CACHE_TEMPLATES_DB = "UPP_Output_Cache_Templates_DB";
        public const string KEY_OUTPUT_CLASSES = "UPP_Output_Classes";
        public const string KEY_OUTPUT_TEMPLATES = "UPP_Output_Templates";
        public const string KEY_OUTPUT_PREFABS = "UPP_Output_Prefabs";
        public const string KEY_COMPILER_DB = "UPP_Compiler_DB";


        public static string Resolve(string path)
        {
            string s = path;
            s = ResolveToken(s, KEY_OUTPUT_CACHE_CLASSES_DB, DEFAULT_OUTPUT_CACHE_CLASSES_DB);
            s = ResolveToken(s, KEY_OUTPUT_CACHE_CLASSES_PATH, DEFAULT_OUTPUT_CACHE_CLASSES_PATH);
            s = ResolveToken(s, KEY_OUTPUT_CACHE_PROPERTIES_PATH, DEFAULT_OUTPUT_CACHE_PROPERTIES_PATH);
            s = ResolveToken(s, KEY_OUTPUT_CACHE_PROPERTIES_DB, DEFAULT_OUTPUT_CACHE_PROPERTIES_DB);
            s = ResolveToken(s, KEY_OUTPUT_CACHE_TEMPLATES_PATH, DEFAULT_OUTPUT_CACHE_TEMPLATES_PATH);
            s = ResolveToken(s, KEY_OUTPUT_CACHE_TEMPLATES_DB, DEFAULT_OUTPUT_CACHE_TEMPLATES_DB);
            s = ResolveToken(s, KEY_OUTPUT_CLASSES, DEFAULT_OUTPUT_CLASSES);
            s = ResolveToken(s, KEY_OUTPUT_TEMPLATES, DEFAULT_OUTPUT_TEMPLATES);
            s = ResolveToken(s, KEY_OUTPUT_PREFABS, DEFAULT_OUTPUT_PREFABS);
            s = ResolveToken(s, KEY_COMPILER_DB, DEFAULT_COMPILER_DB);
            return s;
        }

        private static string ResolveToken(string text, string tokenTxt, string defValue)
        {
            string x = Settings.GetOrSet(tokenTxt, defValue);
            return text.Replace(Token(tokenTxt), x);
        }

        public static string Token(string text)
        {
            return "%" + text + "%";
        }

        public static string Get(string tokenText)
        {
            return Resolve(Token(tokenText));
        }

        
    }
}