﻿using System.Collections;
using System.Collections.Generic;

namespace UPP
{
    public class Position
    {
        private float oldX;
        private float oldY;
        public float X { get { return oldX; } set { SetX(value); } }
        public float Y { get { return oldY; } set { SetY(value); } }

        public delegate void PositionChangedHandler(float oldX, float oldY, float newX, float newY);
        public event PositionChangedHandler PositionChanged;

        private void SetX(float newVal)
        {
            if (newVal != oldX)
            {
                float x = oldX;
                oldX = newVal;
                if (PositionChanged != null)
                    PositionChanged(x, oldY, newVal, oldY);
            }
        }

        private void SetY(float newVal)
        {
            if (newVal != oldY)
            {
                float y = oldY;
                oldY = newVal;
                if (PositionChanged != null)
                    PositionChanged(oldX, y, oldX, newVal);
            }
        }

        public Position()
        {
            this.oldX = 0;
            this.oldY = 0;
        }

        public Position(float x, float y)
        {
            this.oldX = x;
            this.oldY = y;
        }

        public override string ToString()
        {
            return "X: " + this.X.ToString("0.000") + " Y: " + this.Y.ToString("0.000");
        }

    }
}