﻿using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;

namespace UPP
{
    public static class ColorSchemes
    {

        public static void FillTexture(Texture2D texture, Color color)
        {
            Color[] fillColorArray = texture.GetPixels();
            for (var i = 0; i < fillColorArray.Length; ++i)
            {
                fillColorArray[i] = color;
            }
            texture.SetPixels(fillColorArray);
            texture.Apply();
        }

        private static Color _transparent = new Color32(0, 0, 0, 0);
        public static Color Transparent { get { return _transparent; } }

        public static Color BorderColor
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(31, 31, 31, 255)
                : new Color32(145, 145, 145, 255);
            }
        }

        public static Color BorderColorDarker
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(25, 25, 25, 255)
                : new Color32(130, 130, 130, 255);
            }
        }

        public static Color BackgroundColor
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(55, 55, 55, 255)
                : new Color32(194, 194, 194, 255);
            }
        }

        public static Color BackgroundColorLighter
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(62, 62, 62, 255)
                : new Color32(221, 221, 221, 255);
            }
        }

        public static Color BackgroundColorDarker
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(41, 41, 41, 255)
                : new Color32(162, 162, 162, 255);
            }
        }

        public static Color SelectionColor
        {
            get
            {
                return EditorGUIUtility.isProSkin
                ? new Color32(61, 96, 145, 255)
                : new Color32(62, 125, 231, 255);
            }
        }
    }

}