﻿using System.Collections;
using System.Collections.Generic;
using UnityEngine;


namespace UPP.OGUI
{

    public class TableColumn
    {
        private bool _autoSize = true;
        public bool AutoSize { get { return _autoSize; } set { _autoSize = value; } }

        private string _caption = "";
        public string Caption { get { return _caption; } set { SetCaption(value); } }

        private float _width = 100;
        public float Width { get { return _width; } set { SetWidth(value); } }

        private GUIStyle _style = new GUIStyle();
        public GUIStyle Style { get { return _style; } set { SetStyle(value); } }

        private void SetWidth(float newWidth)
        {
            _autoSize = false;
            _width = newWidth;
        }

        private void SetStyle(GUIStyle newStyle)
        {
            _style = newStyle;
            if (_autoSize)
                SetWidthFromCaption();
        }

        private void SetWidthFromCaption()
        {
            Vector2 v = _style.CalcSize(new GUIContent(this._caption));
            this._width = v.x + _style.padding.left + _style.padding.right
                + _style.margin.left + _style.margin.right;
        }

        private void SetCaption(string newCaption)
        {
            _caption = newCaption;
            if (_autoSize)
                SetWidthFromCaption();
        }

        public TableColumn() { }

        public TableColumn(GUIStyle style)
        {
            SetStyle(style);
        }

    }

}