﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;
using UPP.OGUI;

namespace UPP.Engine
{
    public class CompilerWindow : Window
    {
        int width = 500;
        int height = 500;

        Label compTime = null;
        TextBox log = null;

        [MenuItem("Unity++/Compiler")]
        public static void ShowWindow()
        {
            EditorWindow.GetWindow(typeof(CompilerWindow),
                Boolean.Parse(Settings.GetOrSet("UPP_windows_as_utility", true.ToString())),
                "Compiler");
        }

        protected override void PrepareGUI()
        {
            position = new Rect(position.x, position.y, width, height);
            minSize = new Vector2(width, height);

            Label l = new Label("Last time compiled:");
            l.Position = new Position(10, 10);

            string c = Compiler.DB.LastCompilation;
            string s = "Never";
            if (c != "")
                s = c;
            compTime = new Label(s, true);
            compTime.Anchor = new Anchor(true, true, false, false);
            compTime.Position = new Position(width - compTime.Size.Width - 10, 10);

            Label l2 = new Label("Compiler log:");
            l2.Position = new Position(10, 110);

            int logHeight = 340;

            log = new TextBox(String.Join(Environment.NewLine, Compiler.DB.LogMemory.ToArray()));
            log.Anchor = new Anchor(true, true, true, true);
            log.Position = new Position(10, height - logHeight - 35);
            log.AutoSize = false;
            log.Size = new Size(width - 20, logHeight);
            log.ReadOnly = true;

            new DialogConfirmPanel(this, position, "Close", null);

            Button b = new Button("Compile");
            b.AutoSize = false;
            b.Anchor = new Anchor(true, true, false, true);
            b.Position = new Position(10, 40);
            b.Size = new Size(width - 10, 60);
            b.OnClick += B_OnClick;

            Compiler.LogBox = log;
        }

        private void B_OnClick(object sender)
        {
            Compiler.CompileAll();
        }
    }
}