﻿using System;
using System.Collections;
using System.Collections.Generic;
using UnityEditor;
using UnityEngine;
using UPP.OGUI;

namespace UPP
{

    public class FormSettings : OGUI.Window {

        [MenuItem("Unity++/Settings")]
        public static void ShowWindow()
        {
            EditorWindow.GetWindow(typeof(FormSettings), true, "Unity++ Settings");
        }

        private void FillTable(Table t)
        {
            var l = Settings.GetAll();
            foreach (SettingsRecord rec in l)
            {
                t.AddRow(new string[] { rec.key, rec.value });
            }
        }

        protected override void PrepareGUI()
        {
            Table t = new Table(new string[] { "Constant", "Value" });
            t.Dock = DockStyle.Fill;
            t.Columns[0].Width = 200;

            Panel p = new Panel();
            p.Dock = DockStyle.Bottom;
            p.Size.Height = 25;

            Button b = new Button("Close window");
            b.Parent = p;
            b.Size = new Size(150, 23);
            b.Position = new Position(p.Size.Width - b.Size.Width - 1, 1);
            b.Anchor = new Anchor(true, true, true, false);

            FillTable(t);
        }


    }

}